option casemap:none
option frame:auto

UNICODE 				EQU 1
WIN32_LEAN_AND_MEAN 	EQU 1
_WIN64 					EQU 1

include windows.inc
include macros.inc

includelib Kernel32.Lib

include masm64lib.inc

.code

input_wsz proc uses rsi rdi rbx pwszBuffer: ptr WCHAR,ccBuffer:QWORD,nArgs:QWORD,pwszArgs:VARARG
LOCAL hStdOut:HANDLE
LOCAL hStdIn:HANDLE
LOCAL dwWritten:DWORD
LOCAL ConsoleCP:UINT
LOCAL cbBytes:QWORD
LOCAL psz:PCHAR	
LOCAL char[2]:CHAR
LOCAL pwsz:PWCHAR

	and rsp,-16
	add rsp,-8*8
	
	.if rdx < 2
		ret
	.endif
	
	mov pwszBuffer,rcx
	dec rdx
	mov ccBuffer,rdx
	mov nArgs,r8
	mov pwszArgs[0],r9
	
	.if r8
		mov rcx,STD_OUTPUT_HANDLE
		call GetStdHandle
		mov hStdOut,rax
		
		mov rcx,rax
		call GetFileType
		mov rsi,rax
		
		lea rdx,dwWritten
		mov rcx,hStdOut
		call GetConsoleMode
		
		.if rsi & FILE_TYPE_CHAR && eax
			lea rsi,pwszArgs
			.while nArgs
				mov rcx,[rsi]
				call wszSize
			
				mov QWORD ptr [rsp+4*8],0
				lea r9,dwWritten
				mov r8,rax
				mov rdx,rcx
				mov rcx,hStdOut
				call WriteConsole
			
				lea rsi,[rsi+8]
				dec nArgs
			.endw
		.else
			call GetConsoleOutputCP
			mov ConsoleCP,eax
			
			lea rsi,pwszArgs
			.while nArgs
				xor rdx,rdx
				mov [rsp+32+0*8],rdx
				mov [rsp+32+1*8],rdx
				mov [rsp+32+2*8],rdx
				mov [rsp+32+3*8],rdx
				mov r9,-1
				mov r8,[rsi]
				mov ecx,ConsoleCP
				call WideCharToMultiByte
				mov cbBytes,rax
			@@:	test rax,rax
				jz @F	
				
				mov rdx,rax
				mov rcx,GPTR
				call GlobalAlloc
				mov psz,rax
				
				mov rdx,cbBytes
				mov [rsp+32+0*8],rax
				mov [rsp+32+1*8],rdx
				xor rdx,rdx
				mov [rsp+32+2*8],rdx
				mov [rsp+32+3*8],rdx
				mov r9,-1
				mov r8,[rsi]
				mov ecx,ConsoleCP
				call WideCharToMultiByte
				
				mov QWORD ptr [rsp+4*8],0
				lea r9,dwWritten
				mov r8,cbBytes
				lea r8,[r8-1]
				mov rdx,psz
				mov rcx,hStdOut
				call WriteFile
				
				mov rcx,psz
				call GlobalFree
			@@:
				lea rsi,[rsi+8]
				dec nArgs
			.endw
		.endif
	.endif

	mov rcx,STD_INPUT_HANDLE
	call GetStdHandle
	mov hStdIn,rax
	
	mov rcx,rax
	call GetFileType
	mov rsi,rax
	
	lea rdx,dwWritten
	mov rcx,hStdIn
	call GetConsoleMode
	
	.if rsi & FILE_TYPE_CHAR && eax
		
		mov QWORD ptr [rsp+32+0*8],0
		lea r9,dwWritten
		mov r8,ccBuffer
		mov rdx,pwszBuffer
		mov rcx,hStdIn
		call ReadConsoleW
		mov edi,dwWritten
	.else
		call GetConsoleCP
		mov ConsoleCP,eax		
		mov rsi,pwszBuffer
		xor rdi,rdi
		mov char[1],-1
		.while rdi < ccBuffer
			mov QWORD ptr [rsp+32+0*8],0
			lea r9,dwWritten
			mov r8,1
			lea rdx,char[0]
			mov rcx,hStdIn
			call ReadFile
			mov al,char[0]
			mov CHAR ptr [rsi+rdi],al
			lea rdi,[rdi+1]
			.break .if !char || (char[0]==10 && char[1]==13)
			mov char[1],al
		.endw
		
		mov pwsz,alloc(ccBuffer)
		mov rbx,rax
		xor rcx,rcx
		.while rcx < ccBuffer
			movzx rax,CHAR ptr [rsi+rcx]
			mov [rbx+rcx],al
			lea rcx,[rcx+1]
		.endw
		
		mov rax,ccBuffer
		mov QWORD ptr [rsp+32+1*8],rax
		mov QWORD ptr [rsp+32+0*8],rsi
		mov r9,rdi
		mov r8,rbx
		mov rdx,MB_PRECOMPOSED
		mov ecx,ConsoleCP
		call MultiByteToWideChar
		
		free pwsz
		
	.endif
	
	
	mov rsi,pwszBuffer
	mov WCHAR ptr [rsi+rdi*2],0
	.if rdi > 1
		.if WCHAR ptr [rsi+rdi*2-4] == 13 && WCHAR ptr [rsi+rdi*2-2] == 10
			mov WCHAR ptr [rsi+rdi*2-4],0			
		.endif
	.endif
		
	
	ret

input_wsz endp

end