option casemap:none
option frame:auto

UNICODE 				EQU 1
WIN32_LEAN_AND_MEAN 	EQU 1
_WIN64 					EQU 1

include windows.inc
include macros.inc

includelib Kernel32.Lib

include masm64lib.inc

.code
option prologue:none
option epilogue:none

;experimental
uqw2wsz proc uqw:QWORD,pwszBuffer:PWCHAR

	mov r8,0CCCCCCCCCCCCCCCDh
	xor r9,r9
	xor r10,r10
	xor r11,r11
	mov rax,rcx
	mov rcx,rdx
	align 16	
@@:	
	mul r8
	shrd rax,rdx,3
	push rdx
	inc rax
	mov rdx,10
	mul rdx
	lea r9,[r9+rdx]
	shld r10,r9,4
	shl r9,4
	pop rax
	shr rax,3
	lea r11,[r11+1]
	jnz @B
	shrd r9,r10,4
	shr r10,4
	align 16
@@:	
	mov rax,r9
	and rax,0fh
	add rax,30h
	mov WORD ptr [rcx],ax
	shrd r9,r10,4
	shr r10,4
	lea rcx,[rcx+2]
	dec r11
	jnz @B
@@:
	mov WORD ptr [rcx],0
	ret

uqw2wsz endp

;experimental
sqw2wsz proc sqw:SQWORD,pwszBuffer:PWCHAR

	mov r8,0CCCCCCCCCCCCCCCDh
	xor r9,r9
	xor r10,r10
	xor r11,r11
	test rcx,rcx
	.if SIGN?
		neg rcx
		mov WORD ptr [rdx],'-'
		lea rdx,[rdx+2]
	.endif
	mov rax,rcx
	mov rcx,rdx
	align 16	
@@:	
	mul r8
	shrd rax,rdx,3
	push rdx
	inc rax
	mov rdx,10
	mul rdx
	lea r9,[r9+rdx]
	shld r10,r9,4
	shl r9,4
	pop rax
	shr rax,3
	lea r11,[r11+1]
	jnz @B
	shrd r9,r10,4
	shr r10,4
	align 16
@@:	
	mov rax,r9
	and rax,0fh
	add rax,30h
	mov WORD ptr [rcx],ax
	shrd r9,r10,4
	shr r10,4
	lea rcx,[rcx+2]
	dec r11
	jnz @B
@@:
	mov WORD ptr [rcx],0
	ret

sqw2wsz endp

qw2hexwsz proc qwValue:QWORD,pwszBuffer:PWCHAR
	
	.data
		align 32
		q2hws_msk1	QWORD 0f0f0f0f0f0f0f0f0h
		q2hws_msk2	QWORD 00f0f0f0f0f0f0f0fh
		q2hws_msk3	OWORD 30303030303030303030303030303030h
		q2hws_msk4	OWORD 09090909090909090909090909090909h
		q2hws_msk5	OWORD 07070707070707070707070707070707h
	.code
	
	pxor xmm4,xmm4
	mov r8,rcx
	and rcx,q2hws_msk1
	and r8,q2hws_msk2
	shr rcx,4

	movd xmm0,r8
	movd xmm1,r8
	movd xmm2,rcx
	punpcklbw xmm0,xmm2
	punpcklbw xmm1,xmm2
	por xmm0,xmm1
	movdqa xmm1,xmm0
	paddb xmm0,q2hws_msk3
	pcmpgtb xmm1,q2hws_msk4
	pand xmm1,q2hws_msk5
	paddb xmm0,xmm1
	movdqa xmm1,xmm0
	punpckhbw xmm0,xmm4
	punpcklbw xmm1,xmm4
	pshuflw xmm0,xmm0,00011011y
	pshufhw xmm0,xmm0,00011011y
	pshuflw xmm1,xmm1,00011011y
	pshufhw xmm1,xmm1,00011011y
	pshufd xmm0,xmm0,01001110y
	pshufd xmm1,xmm1,01001110y
	
	test rdx,0fh
	.if ZERO?
		movdqa [rdx+0*16],xmm0
		movdqa [rdx+1*16],xmm1
		mov WORD ptr [rdx+2*16],0
		ret
	.else
		movdqu [rdx+0*16],xmm0
		movdqu [rdx+1*16],xmm1
		mov WORD ptr [rdx+2*16],0		
		ret
	.endif

qw2hexwsz endp


; modifies: rax
; rcx will remain unaffected 
wszSize proc pwsz:PWCHAR
	
	xor rax,rax
@@:	test WORD ptr [rcx+rax*2],0ffffh
	lea rax,[rax+1]
	jnz @B
@@:	dec rax
	ret

wszSize endp

; MODIFIES:	rax,r8,r9,r10,r11
; rcx and rdx will remain unaffected
; RETURNS: rax = size of new string in characters (without term. zero). 
;                If the buffer is to small, zero is returned. However,
;                as long as ccBuffer is not zero an termination zero is 
;                written to buffer.
wszcMultiCat proc pwszBuffer:PWCHAR,ccBuffer:QWORD,nArgs:QWORD,pwszArgs:VARARG

	test rdx,rdx
	jz @E
	mov r10,5
	xor rax,rax
	align 8
@@:	test WORD ptr [rcx+rax*2],0ffffh
	jz @F
	cmp rax,rdx
	jae @O
	lea rax,[rax+1]
	jmp @B
@@:	
	test r8,r8
	jz @1
	@L:	movzx r11,WORD ptr [r9]
		test r11,r11
		jz @F
		mov [rcx+rax*2],r11w
		lea rax,[rax+1]
		cmp rax,rdx
		jae @O
		lea r9,[r9+2]
		jmp @L
	@@:	
		dec r8
		jz @1
		mov r9,[rsp+r10*8]
		lea r10,[r10+1]
		jmp @L

	align 16
@1:	mov WORD ptr [rcx+rax*2],0
	ret

	align 16
@O:	mov WORD ptr [rcx+rax*2-2],0
@E:	xor rax,rax
	ret

wszcMultiCat endp

; Description: converts an signed or unsigned value, given through rdx,
;              to an numeric unicode string in specified radix.
; MODIFIES:    rax,rcx,rdx,r8 and r10.
;              r9 will remain unaffected
; Parameters:  
;              pwszBuffer:   pointer to buffer that recive the unicode string. The requied size
;                            depends of the current radix. You will be allways on the save site by using
;                            a size of 132Bytes (66 char.). See also the DQ2WSZ_GET_MAX_SIZE-flag.
;              dqNum:        number to convert. If not changeed by the flags, this is a QWORD
;              uiRadix:      2 - 36
;              dqFlags:      DQ2WSZ_LEADING_ZEROS   print leading zeros. For signed values these also means to print '+' and '-'
;                            DQ2WSZ_LOWER_CASE
;                            DQ2WSZ_SIGNED          dqNum is an signed value
;                            DQ2WSZ_DWORD           dqNum is an DWORD
;                            DQ2WSZ_WORD              "   "  "  WORD
;                            DQ2WSZ_BYTE              "   "  "  BYTE
;                            DQ2WSZ_GET_MAX_SIZE    return (rax) the maximum number of characters (+term. zero) according to the flags.
;                                                   Only r9 is used - all other parameters are ignored.
;                                                   You can use the return value for allocating an buffer.
;                            DQ2WSZ_PLUS            force the print of plus sign
;
;
dq2wsz proc pwszBuffer:PWCHAR,dqNum:QWORD,uiRadix:QWORD,dqFlags:QWORD
LOCAL sz[66]:CHAR
LOCAL sign:DWORD	
	.data
		align 16
		lutU db "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"
		align 16
		lutL db "0123456789abcdefghijklmnopqrstuvwxyz"
		align 16
		nDigits db 0,0,64,41,32,28,25,23,22,21,20,19,18,18,17,17,16,16,16,16,15,15,15,15,14,14,14,14,14,14,14,13,13,13,13,13,13 ; QWORDs
				db 0,0,32,21,16,14,13,12,11,11,10,10, 9, 9, 9, 9, 8, 8, 8, 8, 8, 8, 8, 8, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7 ; DWORDs
				db 0,0,16,11, 8, 7, 7, 6, 6, 6, 5, 5, 5, 5, 5, 5, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4 ; WORDs
				db 0,0, 8, 6, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 ; BYTEs
	.code
	
	.if r8 > 36 || r8 < 2 || r9 & (NOT DQ2WSZ_VALID)
		xor rax,rax
		ret
	.endif
	
	mov r10,r9
	and r10,DQ2WSZ_DWORD or DQ2WSZ_WORD or DQ2WSZ_BYTE
	.if r10
		mov rax,r10
		bsr rax,rax
		bsf r10,r10
		.if r10 != rax
			xor rax,rax
			ret
		.endif
		.if r9 & DQ2WSZ_DWORD
			.if r9 & DQ2WSZ_SIGNED
				movsxd rax,edx
			.else
				mov eax,edx
			.endif
		.elseif r9 & DQ2WSZ_WORD
			.if r9 & DQ2WSZ_SIGNED
				movsx rax,dx
			.else
				movzx rax,ax
			.endif
		.else
			.if r9 & DQ2WSZ_SIGNED
				movsx rax,dl
			.else
				movzx rax,dl
			.endif
		.endif
	.else
		mov rax,rdx
	.endif
	
	.if r9 & DQ2WSZ_GET_MAX_SIZE
		.if r9 & DQ2WSZ_DWORD
			movzx rax,BYTE ptr nDigits[r8][1*SIZEOF nDigits]
		.elseif r9 & DQ2WSZ_WORD
			movzx rax,BYTE ptr nDigits[r8][2*SIZEOF nDigits]
		.elseif r9 & DQ2WSZ_BYTE	
			movzx rax,BYTE ptr nDigits[r8][3*SIZEOF nDigits]
		.else
			movzx rax,BYTE ptr nDigits[r8][0*SIZEOF nDigits]
		.endif
		.if r9 & DQ2WSZ_SIGNED || r9 & DQ2WSZ_PLUS
			lea rax,[rax+1]
		.endif
		lea rax,[rax+1]
		ret
	.endif
	
	
	mov r10,rcx

	mov rdx,8000000000000000h
	xor rcx,rcx
	.if r9 & DQ2WSZ_SIGNED && rax & rdx
		.if rax == rdx
			cqo
			idiv r8
			neg rdx
			.if r9 & DQ2WSZ_LOWER_CASE
				mov dl,BYTE ptr lutL[rdx]
			.else
				mov dl,BYTE ptr lutU[rdx]
			.endif
			mov sz[rcx],dl
			lea rcx,[rcx+1]
		.endif
		neg rax
		mov sign,1
	.else
		mov sign,0
	.endif
	
	.if rax
		.while rax
			xor rdx,rdx
			div r8
			.if r9 & DQ2WSZ_LOWER_CASE
				mov dl,BYTE ptr lutL[rdx]
			.else
				mov dl,BYTE ptr lutU[rdx]
			.endif
			mov sz[rcx],dl
			lea rcx,[rcx+1]		
		.endw
	.else
		mov sz[rcx],'0'
		lea rcx,[rcx+1]	
	.endif
	
	xor rdx,rdx
	.if sign
		mov WORD ptr [r10],'-'
		lea rdx,[rdx+1]
	.elseif (r9 & DQ2WSZ_LEADING_ZEROS && r9 & DQ2WSZ_SIGNED) || r9 & DQ2WSZ_PLUS
		mov WORD ptr [r10],'+'
		lea rdx,[rdx+1]
	.endif
	
	
	
	.if r9 & DQ2WSZ_LEADING_ZEROS
		.if r9 & DQ2WSZ_DWORD
			movzx rax,BYTE ptr nDigits[r8][1*SIZEOF nDigits]
		.elseif r9 & DQ2WSZ_WORD
			movzx rax,BYTE ptr nDigits[r8][2*SIZEOF nDigits]
		.elseif r9 & DQ2WSZ_BYTE	
			movzx rax,BYTE ptr nDigits[r8][3*SIZEOF nDigits]
		.else
			movzx rax,BYTE ptr nDigits[r8][0*SIZEOF nDigits]
		.endif

		sub rax,rcx
		.while rax
			mov WORD ptr [r10+rdx*2],'0'
			lea rdx,[rdx+1]
			lea rax,[rax-1]
		.endw
	.endif
	
	.while rcx
		movzx rax,BYTE ptr sz[rcx-1]
		mov WORD ptr [r10+rdx*2],ax
		lea rcx,[rcx-1]
		lea rdx,[rdx+1]
	.endw
	mov WORD ptr [r10+rdx*2],0
	
	mov rax,r10
	
	ret
	
dq2wsz endp


end